#include <SparkFunbc127.h>
//com3 rx
//com4 tx

BC127 bluetooth(&Serial3);
String rxAddr = "20FABB021C30";
String rx1Addr = "20FABB021AB2";

void initializeSerialPort();
void restoreBackToFactorySettings(BC127 module);
void setParameters(BC127 module);

void setup() {
  initializeSerialPort();
  restoreBackToFactorySettings(bluetooth);
  setParameters(bluetooth);
}

void loop() {
  Serial.println("successful");
  restoreBackToFactorySettings(bluetooth);
  setParameters(bluetooth);
  bluetooth.connect(rx1Addr, BC127::A2DP);
  bluetooth.musicCommands(BC127::PLAY);
  delay(10000);
}


void initializeSerialPort(){
  Serial.begin(9600);
  Serial3.begin(9600);
}

void restoreBackToFactorySettings(BC127 module){

  BC127::opResult restoreCommand = BC127::REMOTE_ERROR;
  BC127::opResult resetCommand = BC127::REMOTE_ERROR;
  BC127::opResult writeCommand = BC127::REMOTE_ERROR;

  while(true){
    restoreCommand = module.restore();
    Serial.println(restoreCommand);
    if(restoreCommand == BC127::SUCCESS) break;
    else restoreCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  while(true){
    writeCommand = module.writeConfig();
    Serial.println(writeCommand);
    if(writeCommand == BC127::SUCCESS) break;
    else writeCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  while(true){
    resetCommand = module.reset();
    Serial.println(resetCommand);
    if(resetCommand == BC127::SUCCESS) break;
    else resetCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  Serial.println("Successful restore");
 
}

void setParameters(BC127 module){
  BC127::opResult restoreCommand = BC127::REMOTE_ERROR;
  BC127::opResult resetCommand = BC127::REMOTE_ERROR;
  BC127::opResult writeCommand = BC127::REMOTE_ERROR;
  BC127::opResult sourceCommand = BC127::REMOTE_ERROR;

  while(true){
    restoreCommand = module.restore();
    Serial.println(restoreCommand);
    if(restoreCommand == BC127::SUCCESS) break;
    else restoreCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  while(true){
    sourceCommand = module.setClassicSource();
    Serial.println(sourceCommand);
    if(sourceCommand == BC127::SUCCESS) break;
    else sourceCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  while(true){
    writeCommand = module.writeConfig();
    Serial.println(writeCommand);
    if(writeCommand == BC127::SUCCESS) break;
    else writeCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  while(true){
    resetCommand = module.reset();
    Serial.println(resetCommand);
    if(resetCommand == BC127::SUCCESS) break;
    else resetCommand = BC127::REMOTE_ERROR;
    delay(800);
  }

  Serial.println("Successful restore");
 
}
